/*
 * OpenEAS Experlog Application Server
 * Web application development and dynamic template scripting engine
 * Copyright (c) 2004 ExperLog SARL - http://www.experlog.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. You should have
 * received a copy of the GNU General Public License along with this program;
 * if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.experlog.util;

/**
 * A timer to handle client connections time-out.
 */
public class ESTimerThread extends Thread {

  long period_ = 1000;
  ESTimer obj_ = null;
  Object info_ = null;

  public ESTimerThread(ESTimer obj, long seconds, Object info) {
    super();
    setDaemon(true);
    if (seconds <= 0) seconds = 1;
    period_ = seconds * 1000;
    obj_ = obj;
    info_ = info;
  }

  public void run() {
    try {
      sleep(period_);
    } catch (InterruptedException e) {
      e.printStackTrace(System.err);
    }
    obj_.tick(info_);
  }

  public String toString() {
    return "ESTimerThread:toString period = [" + period_ + "]\n" +
      "ESTimerThread:toString object = [" + (info_ == null ? "null" : info_.toString()) + "]\n";
  } // method toString

  public void setPeriod(long p) {
    period_ = p;
  } // method setPeriod

} // class ESTimerThread

